-----------------------------------MODULE Bambino---------------------------------------
EXTENDS  Naturals
VARIABLES stato, cond


-----------------------------------------------------------------------------------------------
(* mapping degli stati:
	stato=0 -> contento
	stato=1 -> scontento
*)

Inv == 	/\ stato \in {0,1} 
		/\ cond \in {0,1}

BInit == stato=0 /\ cond=0
----------------------------------------------------------------------------------------------
(* AZIONI *)

alza == cond'= CASE cond=0->1 [] TRUE->cond
abbassa== cond'= CASE cond=1->0 [] TRUE->cond
----------------------------------------------------------------------------------------------
(* EVENTI *)
buio ==	(stato'= CASE stato=0 -> 1 [] TRUE -> stato)
		/\ alza

luce ==	(stato'= CASE stato=1 -> 0 [] TRUE -> stato)
		/\ abbassa

BNext == /\ (buio \/ luce)
----------------------------------------------------------------------------------------------
BSpec == BInit /\ []BNext
LOCAL try == buio /\ luce
AlternaSpec == <>[]try=><>[](stato=0 <=> stato'=1)
THEOREM BSpec => []Inv
=============================================================================================