-----------------------------------MODULE Bambino---------------------------------------
EXTENDS  Naturals
VARIABLES cond1, cond2,stato
-----------------------------------------------------------------------------------------------
(* mapping degli stati:
	stato=0 -> contento
	stato=1 -> scontento
*)

BInv == stato \in {0,1}
		/\ cond1 \in {0,1}
		/\ cond2 \in {0,1}

BInit == stato=0 /\ cond1=0 /\ cond2=0
--------------------------------------------------------------------------------------------------
(* AZIONI *)

LOCAL alza == /\ (cond1'=CASE (stato=0 /\ cond1=0 /\ cond2=1) ->1 [] TRUE ->cond1)
			  /\ (cond2'=CASE (stato=0 /\ cond1=0 /\ cond2=1) ->0 [] TRUE -> cond2)

LOCAL abbassa == /\(cond1'=cond1)
				 /\(cond2'=CASE (stato=1 /\ cond1=1 /\ cond2=1) ->1 [] TRUE ->cond2)
--------------------------------------------------------------------------------------------------
(* EVENTI*)

buio ==	/\(stato'= CASE (stato=0 /\ cond1=0 /\ cond2=1)->1 [] TRUE -> stato)
		/\ alza
		
		
luce ==	/\(stato'= CASE (stato=1 /\ cond1=1 /\ cond2=1)-> 0 [] TRUE -> stato)
		/\ abbassa
	
BNext == \/ buio \/ luce
----------------------------------------------------------------------------------------------
BSpec == BInit /\ [][BNext]_{stato, cond1, cond2}
THEOREM BSpec => []BInv
=============================================================================================
