-----------------------------MODULE main----------------------------------------------------
EXTENDS Naturals
VARIABLES x,y,s1,s2

bambino == INSTANCE Bambino WITH stato<-s1, cond1<-x, cond2<-y
interruttore == INSTANCE Interruttore WITH stato<-s2, cond1<-x, cond2<-y

MInit == bambino!BInit /\ interruttore!IInit /\ x=0 /\ y=0 /\ s1=0 /\ s2=0

MInv == /\ x \in {0,1}
		/\ y \in {0,1}
		/\ s1 \in {0,1}
		/\ s2 \in {0,1}

--------------------------------------------------------------------------------------------

Next ==  \/ bambino!BNext /\ interruttore!INext

Spec== MInit /\ [][Next]_{x,y,s1,s2}

try == <>[] \neg interruttore!abbassa => <>[](x'=0 /\ y'=0)
=====================================================================